%returns both x and y series of the henon map
%henon(x,y,b,c,iters)
%example: [xs ys]=henon(0.1, 0.1, 0.3, 1.4, 1000)  
function[xseries,yseries] = henon(x, y, b, c, iters)

zseries=zeros(1,iters);
yseries=zeros(1,iters);

xt=0;	%temporary variables
yt=0;

for i=1:iters
	xt=(1-c*x*x+b*y);
	yt=x;
	x=xt;
	y=yt;
	xseries(i)=x;
	yseries(i)=y;
end


