
#include<stdio.h>
#include<iostream.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<time.h>

#include "array2d.h"


int num=5;

//we'll use globals for speed and simplicity

long n=32;
long m=32;
double s=1;
double d0=0.000001;
long gaussnum=32;


array2d* wts;
double* x;
double* y;
double* xe;
double* ye;

//assumes input and output are of size n and wts is n by m
void niterate(double* output, double* input, double** wts, long n, long m, double s){
	long i,j,k;
	i=j=k=0;
	double u=0;

	for(i=0;i<n;i++){
	   u=0;
	   for(j=0;j<m;j++){
	     u=u+wts[i][j]*input[j];
	   }
	   output[i]=tanh(s*u);
	}
//	output[i]=tanh(s*u);
}

//d0 is global
double lyapunov(long n, long m, double s, double** wts, long iters){

	long i,j,k;
	i=j=k=0;   

	double* x=new double[n];
	double* xe=new double[n];
	double* y=new double[n];
	double* ye=new double[n];
	double dsum=0;
	double lsum=0;
	double le=0;
	double d1=0;
	//d0 is global

	for(i=0;i<n;i++){
		x[i]=y[i]=1;
		xe[i]=ye[i]=x[i]+d0;
	}
	for(i=0;i<iters;i++){
		for(j=0;j<n;j++){
			x[j]=y[j];
			xe[j]=ye[j];
		}
		
		
		niterate(y,x, wts, n, m,s);
		niterate(ye, xe, wts, n, m, s);
		dsum=0;
		for(j=0;j<n;j++){
		  dsum=dsum+(y[j]-ye[j])*(y[j]-ye[j]);
		 }
		 d1=sqrt(dsum);
		 for(j=0;j<n;j++){ //readjust ye for separation d0
			ye[j]=y[j]+(d0/d1)*(ye[j]-y[j]); 
		 }
		 
		lsum=lsum+log(fabs(d1/d0));
		le=lsum/(double)i;  //running average
	}
	return le;
}
