#include <gl/glut.h>
#include <gl/Glu.h>
#include <gl/GL.h>
#include<stdlib.h>	/* for rand */
#include<stdlib.h>
#include<math.h>
#include<conio.h>

#include<iostream.h>	//because I can...

#include "array2d.h"

#define random rand 


long maxplot=10000;
void myinit(void);
void display(void);
void idle(void);

void KeyboardFunc(unsigned char key, int x, int y);


//defined in neural.C
extern void niterate(double* output, double* input, double** wts, long n, long m, double s);
extern double lyapunov(long n, long m, double s, double** wts, long iters);
//perfect place for globals :)
double lyap=0;
extern array2d* wts;
array2d* scratch;
extern long gaussnum;

extern double* x;
extern double* y;


int n=8;
int m=8;
extern double s;
double sfactor=0.1;
int renew=1;
int findnew=1;
int refresh=1;	//should graphics be redrawn?
double theta=5;	//5 degrees
int animate=0;
int weird=0;

void main(int argc, char** argv){

		void myinit(), display();

		glutInit(&argc, argv);
		glutInitDisplayMode(GLUT_SINGLE|GLUT_RGB);
		//glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE | GLUT_ALPHA);
		glutInitWindowSize(500,500);
		glutInitWindowPosition(0,0);
		glutCreateWindow("NeuroSis by Oguz");
		glutDisplayFunc(display);
		glutIdleFunc(idle);
		glutKeyboardFunc(KeyboardFunc);
		myinit();
		scratch=new array2d(n,m);
		wts=new array2d(n,m);
		//glutFullScreen();
		glutMainLoop();




}

void KeyboardFunc(unsigned char key, int xloc, int yloc){//trap keyboard events


	long i,j,k;
	i=j=k=0;

	switch(key){

	//toggle weird

	case 'w':
		if(weird){
			weird=0;
		}else{
			weird=0;
		}
		refresh=1;
		glutPostRedisplay();
	
	break;		
	//toggle animation
	case 'a':
		if(animate==0){
			animate=1;
		}else{
			animate=0;
		}
	break;

	//refresh
	case 'r':
			refresh=1;
			glutPostRedisplay();
	break;

	case '+':
		refresh=1;
		s=s+sfactor;
		lyap=lyapunov(n,m,s,wts->base,200);


	break;
	
	case '-':
		refresh=1;
		s=s-sfactor;
		lyap=lyapunov(n,m,s,wts->base,200);

	break;

	case 'L':
		refresh=1;
		maxplot*=2;
	break;

	case 'l':
		refresh=1;
		maxplot/=2;
	break;
	

	case 'p': //pause
		
		if(renew==0){
			renew=1;
			cout<<"\nunpaused"<<endl;
		}else{
			renew=0;
			cout<<"\npaused"<<endl;
		}
	break;

	case 'N': //double size of network
		refresh=1;
		delete wts;
		delete scratch;
		delete[]x;
		delete[]y;
		n*=2;
		m*=2;
		wts=new array2d(n,m);
		scratch=new array2d(n,m);
		x=new double[n];
		y=new double[n];
		for(i=0;i<n;i++){
			x[(int)i]=y[(int)i]=1;
		}
		//wts=new array2d(n,m);
		//scratch=new array2d(n,m);
		for(i=0;i<n;i++){
            
			x[i]=y[i]=1;
			for(j=0;j<m;j++){
                        wts->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
			
			}
                            
		}
		lyap=lyapunov(n,m,s,wts->base,200);

	break;


	case 'n':  //halve size of network

		refresh=1;
		delete wts;
		delete scratch;
		delete[]x;
		delete[]y;
		n/=2;
		m/=2;
		if(n<4){	//crude, but it works.  We don't want to get smaller
			n=4;
			m=4;
		}
		wts=new array2d(n,m);
		scratch=new array2d(n,m);
			x=new double[n];
		y=new double[n];
		for(i=0;i<n;i++){
			x[(int)i]=y[(int)i]=1;
		}
		//wts=new array2d(n,m);
		//scratch=new array2d(n,m);
		for(i=0;i<n;i++){
            
			x[i]=y[i]=1;
			for(j=0;j<m;j++){
                        wts->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
			
			}
                            
		}
		lyap=lyapunov(n,m,s,wts->base,200);
	

	break;


	case 'x':		//find new chaotic solution
		findnew=1;
		refresh=1;
	break;

	case 'X':		//fill with new random numbers 

		refresh=1;
		for(i=0;i<n;i++){
                                 
			for(j=0;j<m;j++){
                        wts->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
            
			}
                            
		}
		lyap=lyapunov(n,m,s,wts->base,200);
		glutPostRedisplay();
	break;


	case '8':	//turn num lock on!  
		glRotatef(theta, 1,0,0); //up
			glutPostRedisplay();
	break;

	case '6':
		glRotatef(theta, 0,1,0); //right
			glutPostRedisplay();
	break;

	case '4':
		glRotatef(theta, 0, -1, 0); //left
			glutPostRedisplay();
	break;

	case '2':
		glRotatef(theta, -1, 0, 0); //down?
			glutPostRedisplay();
	break;

	case '7':
		glRotatef(theta, -1, 1, 0); //NW
			glutPostRedisplay();
	break;

	case '9':
		glRotatef(theta, 1, 1, 0); //NE
			glutPostRedisplay();
	break;

	case '1':
		glRotatef(theta, -1, -1, 0); //SW
			glutPostRedisplay();
	break;

	case '3':
		glRotatef(theta, 1, 0, 0); //SE
			glutPostRedisplay();
	break;





	case 'T':
		theta+=1;
	break;

	case 't':
		theta-=1;
		if(theta<0){
			theta=0;
		}
	break;


	}

	cout<<"n m s LE maxplot: "<<n<<" "<<m<<" "<<s<<" "<<lyap<<" "<<maxplot<<endl;


}

void idle(void){
	//will look for chaotic attractors whenever the computer is free
		long i,j,k;
		i=j=k=0;
		static lyapexp=0;

		static int firstrun=1;
/*
		if(firstrun){
			firstrun=0;
			scratch=new array2d(n,m);
		}
*/
		
	
		if(findnew){
			findnew=0; //set by pressing x for neXt
			if(renew){ //LE is negative, so we should fid something else
		  for(i=0;i<n;i++){
                                 
			for(j=0;j<m;j++){
				scratch->base[i][j]=wts->base[i][j];
			}
		}
	
		
randomize:
		//randomize
		for(i=0;i<n;i++){
                                 
			for(j=0;j<m;j++){
                        scratch->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
            
			}
                            
		}
		lyap=lyapunov(n,m,s,scratch->base,200);
		if(lyap<=0){
			goto randomize;
		}
		

		
		//reassign
		for(i=0;i<n;i++){
           for(j=0;j<m;j++){
			   wts->base[i][j]=scratch->base[i][j];
		   }
		
		}

		
	
		lyap=lyapunov(n,m,s,wts->base,200);
		glutPostRedisplay();
				
		}
		}else{
			if(animate){
				glRotatef(theta,0,1,0);
					glutPostRedisplay();
			}

		}
		
		//glutPostRedisplay();
}



void myinit(void){

	/* attributes */
	//glClearColor(1.0, 1.0, 1.0, 0.0);	/* white bkg */
	glClearColor(0.0, 0.0, 0.0, 0.0); //black bkg
	glColor3f(1.0, 0.0, 0.0);	/* draw in red */

	/* set up viewing */
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//gluOrtho2D(0.0, 500.0, 0.0, 500.0);
	glOrtho(-500.0,500.0,-500.0,500.0,-500.0,500.0);
	//glOrtho(-1, 1, -1, 1, -1, 1);

	glMatrixMode(GL_MODELVIEW);


}

void display(void){

	//s=1.2;
	static int firstrun=1;
	/*
	static float i=0;
	static float j=0;
	static float k=0;
	*/
	long i,j,k;
	i=j=k=0;

	if(firstrun==1){
		firstrun=0;
		x=new double[n];
		y=new double[n];
		for(i=0;i<n;i++){
			x[(int)i]=y[(int)i]=1;
		}
		//wts=new array2d(n,m);
		//scratch=new array2d(n,m);
		for(i=0;i<n;i++){
                                 
			for(j=0;j<m;j++){
                        wts->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
            
			}
                            
		}
	}//end if



	/*
		for(i=0;i<n;i++){
                                 
			for(j=0;j<m;j++){
                        wts->base[i][j]=gauss(gaussnum)/(double)sqrt(n);
            
			}
                            
		}
	*/
		
	typedef GLfloat point[3];
	typedef GLfloat point2[2];

	 point vertices[4]={{0.0,0.0,0.0},{250.0,500.0,100.0},{500.0,250.0,250.0},{250.0,100.0,250.0}};
		/* triangle */

	//int i,j,k;

//	long random();	/*standard random number gen */
	/* point2 p={75.0,50.0}; */	/* random point */
	point p={250.0,100.0, 250.0};
	glClear(GL_COLOR_BUFFER_BIT); /*clear the window*/

/*
		p[0]=(p[0]+vertices[j][0])/2.0;
		p[1]=(p[1]+vertices[j][1])/2.0;
		p[2]=(p[2]+vertices[j][2])/2.0;
*/
	/*
	for(i=0;i<1;i+=0.01){
		for(j=0;j<1;j+=0.01){
			p[0]=sin(j);
			p[1]=cos(j);
			p[2]=j;
		}
	}
	*/
	point2 p2;
		i+=0.1;
		p[0]=sin(i);
		p[1]=cos(i);
		p[2]=i;


		/* plot point */
			
		//for(j=-500;j<500;j++){
		//	for(k=-500;k<500;k++){
		
		//if(refresh){ 
			//refresh=0;

		if(refresh){
			refresh=0;
			
			glNewList(1, GL_COMPILE_AND_EXECUTE);
			
				
			for(i=0;i<maxplot;i++){
				for(j=0;j<n;j++){
						x[j]=y[j];
			
				}
					niterate(y, x, wts->base, n, m, s);
					p[0]=500*y[0];
					p[1]=500*y[1];
					p[2]=500*y[2];
					glBegin(GL_POINTS);
					if(weird){
						glRotatef(theta, 0, 1, 0);
					}
						//let's use even more dimensions of the attractor
					glColor3f(y[3], y[4], y[5]);
					glVertex3fv(p);

					glEnd();

				
			}//end for
		 
			glEndList();

				
		}else{
					glCallList(1);
				
		}
			

		/* commented out 12/13/1998 4:18 am for testing

		for(i=0;i<maxplot;i++){
			for(j=0;j<n;j++){
				x[j]=y[j];
			}
			
			niterate(y, x, wts->base, n, m, s);
				p[0]=500*y[0];
				p[1]=500*y[1];
				p[2]=500*y[2];
			
			
			//the following rotate statement for some strange
			//reason makes for really beautiful pictures
			//glRotatef(10,0,1,0);
			
				
			glBegin(GL_POINTS);
			//glColor3f(p[0]/250.0,p[1]/250.0,p[2]/250.0);
			//let's use even more dimensions of the attractor
			glColor3f(y[3], y[4], y[5]);
			//glColor3f(1, 0, 1);
	
			//glVertex2fv(p2);
			glVertex3fv(p);

			glEnd();
			
		}//end for

		end segment commented out 12/13/1998 */


		//}//end if
		
	//}

	glFlush();
	
	//glutPostRedisplay();
}

